﻿Imports System.Windows.Forms

Public Class Channels

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Portcheck()
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub Channels_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Port0CB.Checked = CurrentCurve(0).MeActive
        Port1CB.Checked = CurrentCurve(1).MeActive
        Port2CB.Checked = CurrentCurve(2).MeActive
        Port0ColorB.BackColor = ScreenColor
        Port1ColorB.BackColor = ScreenColor
        Port2ColorB.BackColor = ScreenColor
        ScreenColorB.BackColor = ScreenColor
        GratColorB.BackColor = ScreenColor
        MarkColorB.BackColor = ScreenColor
        ScreenColorB.ForeColor = GraticuleColor
        GratColorB.ForeColor = GraticuleColor
        MarkColorB.ForeColor = MarkerColor
        Port0ColorB.ForeColor = CurrentCurve(0).MeColor
        Port1ColorB.ForeColor = CurrentCurve(1).MeColor
        Port2ColorB.ForeColor = CurrentCurve(2).MeColor
        P0NameTB.Text = CurrentCurve(0).MeName
        P1NameTB.Text = CurrentCurve(1).MeName
        P2NameTB.Text = CurrentCurve(2).MeName
        Off0NUD.Value = CurrentCurve(0).MeOFF
        Off1NUD.Value = CurrentCurve(1).MeOFF
        Off2NUD.Value = CurrentCurve(2).MeOFF
        Select Case LevelRef
            Case 0
                LevelRef0RB.Checked = True
            Case 1
                LevelRef1RB.Checked = True
            Case 2
                LevelRef2RB.Checked = True
            Case Else
                ' ignore it
        End Select
        LScaleNUD.Value = VScale
        LevOffNUD.Value = VOffset
        VSWRCB.Checked = ShowVSWR
    End Sub

    Private Sub Port0ColorB_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Port0ColorB.Click
        ColorDialog1.AnyColor = True
        ColorDialog1.ShowHelp = True
        Dim cMyCustomColors(5) As Color
        For j = 0 To 2
            cMyCustomColors(j) = CurrentCurve(j).MeColor
        Next
        cMyCustomColors(3) = ScreenColor
        cMyCustomColors(4) = GraticuleColor
        cMyCustomColors(5) = MarkerColor
        'Convert colors to integers
        Dim colorBlue As Integer
        Dim colorGreen As Integer
        Dim colorRed As Integer
        Dim iMyCustomColor As Integer
        Dim iMyCustomColors(cMyCustomColors.Length - 1) As Integer

        For index = 0 To cMyCustomColors.Length - 1
            'cast to integer
            colorBlue = cMyCustomColors(index).B
            colorGreen = cMyCustomColors(index).G
            colorRed = cMyCustomColors(index).R

            'shift the bits
            iMyCustomColor = colorBlue << 16 Or colorGreen << 8 Or colorRed

            iMyCustomColors(index) = iMyCustomColor
        Next

        ColorDialog1.CustomColors = iMyCustomColors
        ColorDialog1.Color = Port0ColorB.BackColor
        If ColorDialog1.ShowDialog <> Windows.Forms.DialogResult.Cancel Then
            Port0ColorB.ForeColor = ColorDialog1.Color
        End If
    End Sub

   
    Private Sub Port1ColorB_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Port1ColorB.Click
        ColorDialog1.AnyColor = True
        ColorDialog1.ShowHelp = True
        Dim cMyCustomColors(5) As Color
        For j = 0 To 2
            cMyCustomColors(j) = CurrentCurve(j).MeColor
        Next
        cMyCustomColors(3) = ScreenColor
        cMyCustomColors(4) = GraticuleColor
        cMyCustomColors(5) = MarkerColor
        'Convert colors to integers
        Dim colorBlue As Integer
        Dim colorGreen As Integer
        Dim colorRed As Integer
        Dim iMyCustomColor As Integer
        Dim iMyCustomColors(cMyCustomColors.Length - 1) As Integer

        For index = 0 To cMyCustomColors.Length - 1
            'cast to integer
            colorBlue = cMyCustomColors(index).B
            colorGreen = cMyCustomColors(index).G
            colorRed = cMyCustomColors(index).R

            'shift the bits
            iMyCustomColor = colorBlue << 16 Or colorGreen << 8 Or colorRed

            iMyCustomColors(index) = iMyCustomColor
        Next

        ColorDialog1.CustomColors = iMyCustomColors
        ColorDialog1.Color = Port1ColorB.BackColor
        If ColorDialog1.ShowDialog <> Windows.Forms.DialogResult.Cancel Then
            Port1ColorB.ForeColor = ColorDialog1.Color
        End If
    End Sub

    Private Sub Port2ColorB_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Port2ColorB.Click
        ColorDialog1.AnyColor = True
        ColorDialog1.ShowHelp = True
        Dim cMyCustomColors(5) As Color
        For j = 0 To 2
            cMyCustomColors(j) = CurrentCurve(j).MeColor
        Next

        cMyCustomColors(3) = ScreenColor
        cMyCustomColors(4) = GraticuleColor
        cMyCustomColors(5) = MarkerColor
        'Convert colors to integers
        Dim colorBlue As Integer
        Dim colorGreen As Integer
        Dim colorRed As Integer
        Dim iMyCustomColor As Integer
        Dim iMyCustomColors(cMyCustomColors.Length - 1) As Integer

        For index = 0 To cMyCustomColors.Length - 1
            'cast to integer
            colorBlue = cMyCustomColors(index).B
            colorGreen = cMyCustomColors(index).G
            colorRed = cMyCustomColors(index).R

            'shift the bits
            iMyCustomColor = colorBlue << 16 Or colorGreen << 8 Or colorRed

            iMyCustomColors(index) = iMyCustomColor
        Next

        ColorDialog1.CustomColors = iMyCustomColors
        ColorDialog1.Color = Port2ColorB.BackColor
        If ColorDialog1.ShowDialog <> Windows.Forms.DialogResult.Cancel Then
            Port2ColorB.ForeColor = ColorDialog1.Color
        End If
    End Sub
    Private Sub Portcheck()
        CurrentCurve(0).MeActive = Port0CB.Checked
        CurrentCurve(1).MeActive = Port1CB.Checked
        CurrentCurve(2).MeActive = Port2CB.Checked
        CurrentCurve(0).MeColor = Port0ColorB.ForeColor
        CurrentCurve(1).MeColor = Port1ColorB.ForeColor
        CurrentCurve(2).MeColor = Port2ColorB.ForeColor
        CurrentCurve(0).MeName = P0NameTB.Text
        CurrentCurve(1).MeName = P1NameTB.Text
        CurrentCurve(2).MeName = P2NameTB.Text
        CurrentCurve(0).MeOFF = Off0NUD.Value
        CurrentCurve(1).MeOFF = Off1NUD.Value
        CurrentCurve(2).MeOFF = Off2NUD.Value
        If LevelRef0RB.Checked Then
            LevelRef = 0
        Else
            If LevelRef1RB.Checked Then
                LevelRef = 1
            Else
                If LevelRef2RB.Checked Then
                    LevelRef = 2
                Else
                    ' Don't know so leave LevelRef as is
                End If
            End If
        End If
        ScreenColor = ScreenColorB.BackColor
        GraticuleColor = GratColorB.ForeColor
        MarkerColor = MarkColorB.ForeColor
        VScale = LScaleNUD.Value
        VOffset = LevOffNUD.Value
        ShowVSWR = VSWRCB.Checked
    End Sub

  
    Private Sub ScreenColorB_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ScreenColorB.Click

        ColorDialog1.AnyColor = True
        ColorDialog1.ShowHelp = True
        Dim cMyCustomColors(5) As Color
        For j = 0 To 2
            cMyCustomColors(j) = CurrentCurve(j).MeColor
        Next
        cMyCustomColors(3) = ScreenColor
        cMyCustomColors(4) = GraticuleColor
        cMyCustomColors(5) = MarkerColor

        'Convert colors to integers
        Dim colorBlue As Integer
        Dim colorGreen As Integer
        Dim colorRed As Integer
        Dim iMyCustomColor As Integer
        Dim iMyCustomColors(cMyCustomColors.Length - 1) As Integer

        For index = 0 To cMyCustomColors.Length - 1
            'cast to integer
            colorBlue = cMyCustomColors(index).B
            colorGreen = cMyCustomColors(index).G
            colorRed = cMyCustomColors(index).R

            'shift the bits
            iMyCustomColor = colorBlue << 16 Or colorGreen << 8 Or colorRed

            iMyCustomColors(index) = iMyCustomColor
        Next

        ColorDialog1.CustomColors = iMyCustomColors
        ColorDialog1.Color = ScreenColorB.BackColor
        If ColorDialog1.ShowDialog <> Windows.Forms.DialogResult.Cancel Then
            Port0ColorB.BackColor = ColorDialog1.Color
            Port1ColorB.BackColor = ColorDialog1.Color
            Port2ColorB.BackColor = ColorDialog1.Color
            ScreenColorB.BackColor = ColorDialog1.Color
            GratColorB.BackColor = ColorDialog1.Color
            MarkColorB.BackColor = ColorDialog1.Color
        End If
        
    End Sub

    
    Private Sub GratColorB_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GratColorB.Click
        ColorDialog1.AnyColor = True
        ColorDialog1.ShowHelp = True
        Dim cMyCustomColors(5) As Color
        For j = 0 To 2
            cMyCustomColors(j) = CurrentCurve(j).MeColor
        Next
        cMyCustomColors(3) = ScreenColor
        cMyCustomColors(4) = GraticuleColor
        cMyCustomColors(5) = MarkerColor

        'Convert colors to integers
        Dim colorBlue As Integer
        Dim colorGreen As Integer
        Dim colorRed As Integer
        Dim iMyCustomColor As Integer
        Dim iMyCustomColors(cMyCustomColors.Length - 1) As Integer

        For index = 0 To cMyCustomColors.Length - 1
            'cast to integer
            colorBlue = cMyCustomColors(index).B
            colorGreen = cMyCustomColors(index).G
            colorRed = cMyCustomColors(index).R

            'shift the bits
            iMyCustomColor = colorBlue << 16 Or colorGreen << 8 Or colorRed

            iMyCustomColors(index) = iMyCustomColor
        Next

        ColorDialog1.CustomColors = iMyCustomColors
        ColorDialog1.Color = GratColorB.ForeColor
        If ColorDialog1.ShowDialog <> Windows.Forms.DialogResult.Cancel Then
            
            ScreenColorB.ForeColor = ColorDialog1.Color
            GratColorB.ForeColor = ColorDialog1.Color

        End If

    End Sub

    Private Sub MarkColorB_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MarkColorB.Click
        ColorDialog1.AnyColor = True
        ColorDialog1.ShowHelp = True
        Dim cMyCustomColors(5) As Color
        For j = 0 To 2
            cMyCustomColors(j) = CurrentCurve(j).MeColor
        Next
        cMyCustomColors(3) = ScreenColor
        cMyCustomColors(4) = GraticuleColor
        cMyCustomColors(5) = MarkerColor

        'Convert colors to integers
        Dim colorBlue As Integer
        Dim colorGreen As Integer
        Dim colorRed As Integer
        Dim iMyCustomColor As Integer
        Dim iMyCustomColors(cMyCustomColors.Length - 1) As Integer

        For index = 0 To cMyCustomColors.Length - 1
            'cast to integer
            colorBlue = cMyCustomColors(index).B
            colorGreen = cMyCustomColors(index).G
            colorRed = cMyCustomColors(index).R

            'shift the bits
            iMyCustomColor = colorBlue << 16 Or colorGreen << 8 Or colorRed

            iMyCustomColors(index) = iMyCustomColor
        Next

        ColorDialog1.CustomColors = iMyCustomColors
        ColorDialog1.Color = MarkColorB.ForeColor
        If ColorDialog1.ShowDialog <> Windows.Forms.DialogResult.Cancel Then
            
            MarkColorB.ForeColor = ColorDialog1.Color
        End If

    End Sub

End Class
