﻿Public Class Markers
    Public minsize As Size
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        sweeper.clearallmarkers()
    End Sub

    Private Sub Markers_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
       sweeper.clearallmarkers()
        sweeper.Marker0CB.Checked = False
        sweeper.Marker1CB.Checked = False
        sweeper.Marker2CB.Checked = False
    End Sub

  
 
    Private Sub Zoomin()
        Dim maxfreq As Double = 0
        Dim minfreq As Double = 3000000000
        Dim tempf As Double
        If CurrentCurve(0).NumMarkers + CurrentCurve(1).NumMarkers + CurrentCurve(2).NumMarkers < 2 Then
            MsgBox("You need at least two markers to use this feature")
        Else
            sweeper.stopsweep() ' stop auto just in case
            For j = 0 To 2
                With CurrentCurve(j)
                    For i = 0 To .NumMarkers - 1
                        tempf = .Values(.Markers(i)).RF
                        If tempf > maxfreq Then maxfreq = tempf
                        If tempf < minfreq Then minfreq = tempf
                    Next
                End With
            Next

            If minfreq <> 3000000000 Then
                sweeper.MinNUD.Value = minfreq
            End If
            If maxfreq <> 0 Then
                sweeper.MaxNUD.Value = maxfreq
            End If

            sweeper.clearallmarkers()
            sweeper.DoSweep()

        End If
    End Sub
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click

        sweeper.clearallmarkers()
        sweeper.Marker0CB.Checked = False
        sweeper.Marker1CB.Checked = False
        sweeper.Marker2CB.Checked = False
        Me.Close()
    End Sub

   
    Private Sub MarkList_DrawItem(ByVal sender As Object, ByVal e As System.Windows.Forms.DrawItemEventArgs) Handles MarkList.DrawItem
        Dim ItemFontColor As Color
        Dim myStringFormat As New StringFormat
        Dim tabspace As Single = Flab.Location.X
        Dim tabStops As Single() = {tabspace, tabspace}
        myStringFormat.SetTabStops(0.0F, tabStops)
        MarkList.BackColor = ScreenColor
        ' Draw the background of the ListBox control for each item.
        e.DrawBackground()

        If e.Index > -1 Then ' only draw it if there is something there.
            ' Determine the color of the brush to draw each item based the first digit   

            Select Case MarkList.Items(e.Index).substring(0, 1)
                Case "0"
                    ItemFontColor = CurrentCurve(0).MeColor
                Case "1"
                    ItemFontColor = CurrentCurve(1).MeColor
                Case "2"
                    ItemFontColor = CurrentCurve(2).MeColor
                Case Else
                    ItemFontColor = Color.Black
            End Select

            Dim mybrush As New SolidBrush(ItemFontColor)
            ' Draw the current item text based on the current Font and the custom brush settings.
            e.Graphics.DrawString(MarkList.Items(e.Index).ToString(), e.Font, mybrush, e.Bounds, myStringFormat)

        End If

        '' If the ListBox has focus, draw a focus rectangle around  _ 
        '' the selected item.
        'e.DrawFocusRectangle()

    End Sub

 
    Private Sub MarkTrough()
        Dim mysamp As Integer
        Dim mysegs As Integer
        Dim mymini As Integer
        Dim AllFull As Boolean = False

        sweeper.stopsweep() ' stop auto just in case
        sweeper.clearallmarkers()
        For j = 0 To 2
            With CurrentCurve(j)
                If .MeActive And MarkersOn(j) And .NumPoints > 10 Then
                    AllFull = False
                    For mysegs = 1 To 10 ' keep dividing down the segment size looking for min in sample untill we hit 10 segments or use up all markers
                        mysamp = Math.Truncate(.NumPoints / mysegs)
                        For mystart = 0 To .NumPoints - mysamp Step mysamp
                            mymini = mynull(.Values, mystart, mystart + mysamp)
                            If mymini <> mystart And mymini <> mystart + mysamp And Math.Abs(.Values(mymini).DL - myavg(.Values, mystart, mystart + mysamp)) > 3 Then
                                'if it is not the first or last item and it is more that 2 different than the average then try to mark it.
                                If Setmarker(mymini, j) = -1 Then
                                    'no more free markers
                                    AllFull = True
                                End If

                            End If
                            If AllFull Then Exit For 'we have as many markers as we can have
                        Next
                        If AllFull Then Exit For
                    Next
                End If
            End With
        Next
        updatemarkers()
        sweeper.CROScreen.Refresh()
    End Sub
    Private Function myavg(ByRef myarray() As DataPoint, ByVal ifrom As Integer, ByVal ito As Integer) As Double
        ' returns the average value of Display Level (DL) elements from ifrom  to ito of myarray
        Dim mysum As Double = 0
        For j = ifrom To ito
            mysum = mysum + myarray(j).DL
        Next
        myavg = mysum / (ito - ifrom + 1)
    End Function
  
    Private Function mynull(ByRef myarray() As DataPoint, ByVal ifrom As Integer, ByVal ito As Integer) As Integer
        ' returns the index of the smallest value of Display Level (DL) elements from ifrom  to ito of myarray 
        Dim mymin As Double = 1000
        Dim minindex As Integer
        For j = ifrom To ito
            If myarray(j).DL < mymin Then
                mymin = myarray(j).DL
                minindex = j
            End If
        Next
        mynull = minindex
    End Function
    Private Function mypeak(ByRef myarray() As DataPoint, ByVal ifrom As Integer, ByVal ito As Integer) As Integer
        ' returns the index of the largest value of Display Level (DL) elements from ifrom  to ito of myarray 
        Dim mymax As Double = -1000
        Dim maxindex As Integer
        For j = ifrom To ito
            If myarray(j).DL > mymax Then
                mymax = myarray(j).DL
                maxindex = j
            End If
        Next
        mypeak = maxindex
    End Function



    Private Sub Markers_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.TopMost = True
        minsize = Me.Size
    End Sub

    'Private Sub Markers_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize

    'End Sub

    Private Sub Markers_ResizeEnd(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ResizeEnd
        Me.Refresh()
    End Sub
    Private Sub MarkPeaks()
        Dim mysamp As Integer
        Dim mysegs As Integer
        Dim mymaxi As Integer
        Dim AllFull As Boolean = False

        sweeper.stopsweep() ' stop auto just in case
        sweeper.clearallmarkers()
        For j = 0 To 2
            With CurrentCurve(j)
                If .MeActive And MarkersOn(j) And .NumPoints > 10 Then
                    AllFull = False
                    For mysegs = 1 To 10 ' keep dividing down the segment size looking for max in sample untill we hit 10 segments or use up all markers
                        mysamp = Math.Truncate(.NumPoints / mysegs)
                        For mystart = 0 To .NumPoints - mysamp Step mysamp
                            mymaxi = mypeak(.Values, mystart, mystart + mysamp)
                            If mymaxi <> mystart And mymaxi <> mystart + mysamp And Math.Abs(.Values(mymaxi).DL - myavg(.Values, mystart, mystart + mysamp)) > 3 Then
                                'if it is not the first or last item and it is more that 2 different than the average then try to mark it.
                                If Setmarker(mymaxi, j) = -1 Then
                                    'no more free markers
                                    AllFull = True
                                End If

                            End If
                            If AllFull Then Exit For 'we have as many markers as we can have
                        Next
                        If AllFull Then Exit For
                    Next
                End If
            End With
        Next
        updatemarkers()
        sweeper.CROScreen.Refresh()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Zoomin()
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        MarkPeaks()
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        MarkTrough()
    End Sub

    
    Private Sub MarkList_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MarkList.MouseClick

    End Sub

    Private Sub MarkList_MouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MarkList.MouseDoubleClick
        Dim mycurve As Integer
        Dim mymarkerno As Integer
        Dim myindex As Integer
        ' MsgBox(MarkList.SelectedIndex.ToString)
        If MarkList.SelectedIndex <> -1 Then
            mycurve = CInt(MarkList.Items(MarkList.SelectedIndex).substring(0, 1))
            mymarkerno = CInt(MarkList.Items(MarkList.SelectedIndex).substring(2, 1)) - 1
            myindex = CurrentCurve(mycurve).Markers(mymarkerno)
            SetResetmarker(myindex, mycurve)
            updatemarkers()
            sweeper.CROScreen.Refresh()
        End If
    End Sub
End Class